/**
 * Vezbe 6
 * Preduslov predavanja zakljucno sa Mape i skupovi
 * Klasa Projekat modelira projekat u gradj. firmi
 */
import java.util.ArrayList;
import java.util.HashSet;
public class Projekat {
    private String ime, opis;
    private Projektant glavni;  // glavni projektant
    private ArrayList<Projektant> projektanti;  // ostali projektanti na projektu
    /**
     * Kreira projekat sa imenom, opisom i glavnim projektantom
     */
    public Projekat(String ime, String opis, Projektant p){
        this.ime = ime;
        this.opis = opis;
        glavni = p;
        projektanti = new ArrayList<>();
    }    
    /**
     * Vraca ime projekta
     */
    public String dajIme(){ return ime; }
    /**
     * Vraca opis projekta
     */
    public String dajOpis(){ return opis; }
    /**
     * Vraca glavnog projektanta
     */
    public Projektant dajGlavnog(){ return glavni; }
    /**
     * Vraca projektante
     */
    public ArrayList<Projektant> dajProjektante(){ return projektanti; }
    /**
     * Promena imena projekta
     */
    public void promeniIme(String ime){ this.ime = ime; }
    /**
     * Promena opisa projekta
     */
    public void promeniOpis(String opis){ this.opis = opis; }
    /**
     * Promena glavnog projektanta
     */
    public void promeniGlavnog(Projektant p){ glavni = p; }
    /**
     * Dodaj projektanta na projekat
     */
    public void dodajProjektanta(Projektant p){ 
        if(!projektanti.contains(p))
            projektanti.add(p);
    }
    /**
     * Ukloni projektanta sa projekta
     */
    public void ukloniProjektanta(Projektant p){ 
        projektanti.remove(p);
    }
    /** 
     * Stampa informacije o projektantima sa projekta
     */
    public void listaProjektanata(){
        System.out.println("Glavni projektant: ");
        glavni.info();
        for(Projektant p : projektanti){
            p.info();
        }        
    }
    /** 
     * Vraca projektante sa platom vecom od specificirane
     */
    public ArrayList<Projektant> projektantiSaPlatomPlus(double limit){
        ArrayList<Projektant> lista = new ArrayList<>();
        for(Projektant p : projektanti){
            if(p.dajPlatu() > limit) {
                lista.add(p);
            }
        }
        return lista;
    }
    /**
     * Vraca sve tipove licenci na projektu
     */
    public HashSet<String> tipoviLicenci(){
        HashSet<String> tipovi = new HashSet<>();
        for(Projektant p : projektanti){
            for(String l : p.dajLicence()){
                tipovi.add(l.substring(0,3));
            }
        }
        return tipovi;
    }    
}













