/**
 * Vezbe 6
 * Preduslov predavanja zakljucno sa Mape i skupovi
 * Klasa Projektant modelira projektanta u gradj. firmi
 */
import java.util.HashSet;
public class Projektant {
    
    private String ime, prezime;
    private HashSet<String> licence;
    private double plata;
    
    /**
     * Kreira projektanta 
     */
    public Projektant(String ime, String prezime){
        this.ime = ime;
        this.prezime = prezime;
        licence = new HashSet<>();
        plata = 0;
    }
    /**
     * Vraca ime projektanta
     */
    public String dajIme(){ return ime; }
    /**
     * Vraca prezime projektanta
     */
    public String dajPrezime(){ return prezime; }
    /**
     * Vraca platu projektanta
     */
    public double dajPlatu(){ return plata; }
    /**
     * Vraca licence projektanta
     */
    public HashSet<String> dajLicence(){ return licence; }
    /**
     * Promena plate projektanta
     */
    public void postaviPlatu(double plata){ this.plata = plata; }
    /**
     * Dodaj licencu projektantu
     */
    public void dodajLicencu(String lic){ 
        licence.add(lic);
    }
    /**
     * Oduzmi licencu projektantu
     */
    public void oduzmiLicencu(String lic){ 
        licence.remove(lic);
    }
    /**
     * Stampa informacije o projektantu
     * 
     */  
    public void info(){
        System.out.println("Projektant: " + ime + " " + prezime);
        System.out.println("Plata: " + plata);
        int i = 0;
        if(!licence.isEmpty() ){ // moze i licence.size() != 0
            for(String lic : licence){
                i++;
                System.out.println("Licenca " + i + ": " + lic);
            }
        } else {System.out.println("Nema licence");}
    }
    /**
     * Ispituje da li dva projektanta imaju bar jednu licencu istog tipa
     */
    public boolean porediLicence(Projektant p){ 
        for(String moja : licence){
            for(String njegova : p.dajLicence()){
                if (moja.substring(0,3).equals(njegova.substring(0,3))){
                    return true;
                }
            }
        }
        return false;
    }
    
    public HashSet<String> zajednickeLicence(Projektant p){ 
        HashSet<String> zajednicke = new HashSet<>();
        for(String moja : licence){
            for(String njegova : p.dajLicence()){
                if (moja.substring(0,3).equals(njegova.substring(0,3))){
                    zajednicke.add(moja.substring(0,3));
                    break;
                }
            }  
        }
        return zajednicke;
    }
    
    
}
